"""
Module for checking artefact names against compliance standards.

This module provides the `CheckArtefactName` class, which is used to validate
the naming conventions of artefacts to ensure they meet specified compliance
standards.

Classes:
    CheckArtefactName: A class that performs validation on artefact names.
"""

import re

from ska_cicd_artefact_validations.core.artefact import Artefact
from ska_cicd_artefact_validations.core.check import Check
from ska_cicd_artefact_validations.core.logging import logging
from ska_cicd_artefact_validations.core.message_generator import MessageType


class CheckArtefactName(Check):
    """
    A class that performs validation on artefact names.

    This class checks the naming conventions of artefacts to ensure they
    adhere to the specified regex pattern, logging errors and providing
    mitigation strategies if the name is non-compliant.

    Attributes:
        feature_toggle: The feature toggle associated with this check.
    """

    feature_toggle = "check-component-name"

    def __init__(self):
        pass

    async def check(self, artefact: Artefact):
        """
        Checks if the artefact name complies with naming standards.

        This method uses a regex pattern to validate the artefact name,
        ensuring it follows the defined naming conventions.

        :param artefact: The artefact whose name is to be validated.
        :return: True if the artefact name is compliant, otherwise False.
        """
        artefact_name = artefact.name
        logging.debug("Artefact Name: %s", artefact_name)
        regex = r"^(ska-[a-z0-9]+(?:-[a-z0-9]+)*|(?:[a-z0-9-]+/)*ska-[a-z0-9-]+[a-z0-9])$"  # pylint: disable=line-too-long # noqa: E501

        key_match = re.search(regex, artefact_name)
        if not key_match:
            logging.error("Artefact Name is invalid! - %s", artefact_name)
            return False

        return True

    async def type(self) -> MessageType:
        """
        Returns the type of message generated by this check.

        :return: MessageType.FAILURE indicating a failed compliance check.
        """
        return MessageType.FAILURE

    async def description(self) -> str:
        """
        Provides a description of the artefact name compliance check.

        :return: A string describing the nature of the check failure.
        """
        return "Non-compliant Artefact Name"

    async def mitigation_strategy(self) -> str:
        """
        Provides a mitigation strategy if the artefact name is non-compliant.

        This method guides the user on how to correct the artefact name
        according to the defined standards.

        :return: A string with the mitigation strategy and a link to the
            relevant guidelines.
        """
        return (
            "Artefact name is invalid! Please refer to "
            "[the developer portal](https://developer.skatelescope.org/en/latest/tools/software-package-release-procedure.html#artefact-naming) "  # pylint: disable=line-too-long # noqa: E501
            "to correct this issue."
        )
